// $Id: CalButton.java,v 1.1 1996/11/25 01:09:45 asf Exp $

//    This file is part of Cafe au Lys
//    Copyright (C) 1996  Allen S. Firstenberg
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
// 
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
// 
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import java.awt.*;

class CalButton extends Button{

//---------------------------------------------------------------------------

  public CalButton(){
    super();
  }

//---------------------------------------------------------------------------

  public CalButton( String label ){
    super( label );
  }

//---------------------------------------------------------------------------

  /*
   * Does this event reflect a CalButton (or any button?) being "hit"
   */
  static boolean buttonHit( Event e ){
    boolean hit = false;
    String platform = CalValue.get( "SYSTEM", "platform" );

    if( e.target instanceof CalButton ){

      switch( e.id ){
        case Event.MOUSE_UP:
          if( platform.equalsIgnoreCase( "Netscape" ) ||
              platform.equalsIgnoreCase( "Microsoft" ) ||
              platform.equalsIgnoreCase( "JDK1.1" ) )hit = true;
          break;
        case Event.KEY_RELEASE:
          if( platform.equalsIgnoreCase( "Netscape" ) ||
              platform.equalsIgnoreCase( "Microsoft" ) ||
              platform.equalsIgnoreCase( "Unknown" ) ||
              platform.equalsIgnoreCase( "JDK1.0" ) ||
              platform.equalsIgnoreCase( "JDK1.1" ) )hit = true;
          break;
        case Event.ACTION_EVENT:
          if( platform.equalsIgnoreCase( "JDK1.0" ) )hit = true;
          break;
      }
      
    }

    return hit;
  }

//---------------------------------------------------------------------------

  public boolean handleEvent( Event e ){
    boolean ret = false;

    if( buttonHit( e ) ){
      ret = hit( e );
    }

    return ret;
  }

//---------------------------------------------------------------------------

  public boolean hit( Event e ){
    return false;
  }

//---------------------------------------------------------------------------

}
