// $Id: CalTest.java,v 1.2 1996/10/24 00:45:57 asf Exp $

//    This file is part of Cafe au Lys
//    Copyright (C) 1996  Allen S. Firstenberg
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
// 
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
// 
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import java.awt.*;
import java.applet.Applet;

public class CalTest extends Applet{

//---------------------------------------------------------------------------

  final int num = 5;
  Buffer bwin[];

  CalStatus status;

  CalTestSystem system;


//---------------------------------------------------------------------------

  public void init(){
    status = new CalStatus();
    status.add( "Starting test" );
    setLayout( new BorderLayout() );
    add( "Center", status );

    CalValue.putBool( "SYSTEM", "isnetscape", true );
    CalValue.put( "GLOBAL", "fontsize", "8" );

    bwin = new Buffer[num];
    int co;
    for( co=0; co<num; co++ ){
      bwin[co] = new Buffer();
    }
  }

//---------------------------------------------------------------------------

  public void start(){

    CalTextWindow win[];

    system = new CalTestSystem( status, this );
    system.start();

    win = new CalTextWindow[num];
    int co;
    for( co=0; co<num; co++ ){
      try{
        win[co] = new CalTextWindow( "test" + co, status, 
                                     bwin[co], bwin[co+1], bwin[co] );
      } catch( ArrayIndexOutOfBoundsException aioobe ){
        win[co] = new CalTextWindow( "test" + co, status, 
                                     bwin[co], bwin[0], bwin[co] );
      }
    }

    try{
      system.join();
    } catch( InterruptedException ie ){
    }
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

class CalTestSystem implements Runnable{

  Thread thread;

  CalStatus statusbar;
  CalTest applet;

//---------------------------------------------------------------------------

  CalTestSystem( CalStatus s, CalTest a ){
    statusbar = s;
    applet = a;
  }

//---------------------------------------------------------------------------

  public void start(){
    if( thread == null ){
      thread = new Thread( this, "CalSystem" );
      thread.start();
    }
  }

//---------------------------------------------------------------------------

  public void run(){
    String oldstatus = "";
    String status;
    try{
      status = CalValue.get( "SYSTEM", "status" );
    } catch( CalUnknownValueException uve1 ){
      status = "";
    }
    
    while( !status.equalsIgnoreCase( "shutdown" ) ){
      try{
        thread.sleep( 1000 );
        status = CalValue.get( "SYSTEM", "status" );
      } catch( InterruptedException ie ){
        System.out.println( "InterruptedException in CalSystem" );
      } catch( CalUnknownValueException uve2 ){
        status = "unknown";
      }
      if( status != oldstatus ){
        statusbar.add( "Status changed to '" + status +"'" );
        oldstatus = status;
      }
    }

    try{
      if( CalValue.get( "SYSTEM", "apptype" ).equalsIgnoreCase("applet") ){
        //applet.close_up();
        statusbar.add( "You may now close this page." ); 
        //applet.destroy();   // @@@ Does this work?
      } else {
        // application
        System.exit( 0 );
      }
    } catch( CalUnknownValueException uve3 ){
      statusbar.add( "Unknown app type.  Cannot close down." );
    }

  }

//---------------------------------------------------------------------------

  public void stop(){
    System.out.println( "Stopping " + thread.getName() );
    thread.stop();
    thread = null;
    System.out.println( "Stopped" );
  }

//---------------------------------------------------------------------------

  public void join() throws InterruptedException{
    thread.join();
  }

//---------------------------------------------------------------------------

}

