// $Id: CalUtil.java,v 1.1 1996/05/30 01:24:51 asf Exp $

//    This file is part of Cafe au Lys
//    Copyright (C) 1996  Allen S. Firstenberg
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
// 
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
// 
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import java.util.*;

//***************************************************************************

class CalUtil{

//---------------------------------------------------------------------------

  static public String[] split( String s, String tokens ){

    String ret[];
    int num_param;

    StringTokenizer words = new StringTokenizer( s, tokens ,false );

    // How many parameters are there?
    num_param = words.countTokens();
    ret = new String[num_param];

    // Get the tokens out
    int co_param = 0;
    while( words.hasMoreTokens() ){
      ret[co_param] = words.nextToken();
      co_param++;
    }

    return ret;
  }

//---------------------------------------------------------------------------

  static public String[] split( String s ){

    String ret[] = split( s, " \r\n" );
    return ret;
  }

//---------------------------------------------------------------------------

  static public String unsplit( String[] s, String sep, int start ){
    String ret = "";

    int size = s.length;
    int co;

    for( co = start; co<size; co++ ){
      if( co != start ){
        ret = ret + sep;
      }
      ret = ret + s[co];
    }

    return ret;
  }

//---------------------------------------------------------------------------

  static public String unsplit( String[] s, String sep ){
    return unsplit( s, sep, 0 );
  }

//---------------------------------------------------------------------------

  static public String remove( String s, String cs ){
    // Remove all the characters in cs from s

    String words[] = split( s, cs );
    String ret = unsplit( words, "" );

    return ret;
    
  }

//---------------------------------------------------------------------------

  static public String replace( String s, String r, String w ){
    // Replace all the occurances of "r" with "w" in string "s"

    String words[] = split( s, r );
    String ret = unsplit( words, w );

    return ret;
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

class Coordinate{

  int v_x;
  int v_y;

//---------------------------------------------------------------------------

  Coordinate( int x, int y ){
    v_x = x;
    v_y = y;
  }

//---------------------------------------------------------------------------

  public int x(){
    return v_x;
  }

//---------------------------------------------------------------------------

  public int y(){
    return v_y;
  }

//---------------------------------------------------------------------------

  public boolean lt( Coordinate c ){
    boolean ret = false;

    if( v_y < c.y() ){
      ret = true;
    } else if( (v_y == c.y()) && (v_x < c.x()) ){
      ret = true;
    }

    return ret;
  }

//---------------------------------------------------------------------------

  public boolean gt( Coordinate c ){
    boolean ret = false;

    if( v_y > c.y() ){
      ret = true;
    } else if( (v_y == c.y()) && (v_x > c.x()) ){
      ret = true;
    }

    return ret;
  }

//---------------------------------------------------------------------------

  public boolean eq( Coordinate c ){
    boolean ret = false;

    if( (v_x == c.x()) && (v_y == c.y()) ){
      ret = true;
    }

    return ret;
  }

//---------------------------------------------------------------------------

  public boolean le( Coordinate c ){
    boolean ret = lt( c ) || eq( c );
    return ret;
  }

//---------------------------------------------------------------------------

  public boolean ge( Coordinate c ){
    boolean ret = gt( c ) || eq( c );
    return ret;
  }

//---------------------------------------------------------------------------

  public boolean ne( Coordinate c ){
    boolean ret = !eq( c );
    return ret;
  }

//---------------------------------------------------------------------------

}

