// $Id: Quit.java,v 1.2 1996/11/25 01:16:09 asf Exp $

//    This file is part of Cafe au Lys
//    Copyright (C) 1996  Allen S. Firstenberg
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
// 
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
// 
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import java.awt.*;

//***************************************************************************

class QuitWindow extends CalFrame{

  Buffer tonet;

  Label text;

  CheckboxGroup method;
  Checkbox method_detach;
  Checkbox method_bye;
  Checkbox method_terminate;

  Checkbox terminate_all;

  Panel blurbbox;
  TextField blurb;

  Panel buttonbox;
  CalButton ok;
  CalButton cancel;
  CalButton help;

  GridBagLayout layout;
  GridBagConstraints gbc;

//---------------------------------------------------------------------------

  QuitWindow( Buffer n, String t ){
    super( t );
    tonet = n;

    text = new Label( "Are you sure you want to quit?", Label.CENTER );

    // @@@ Should use system settings to find out what to default to
    method = new CheckboxGroup();
    method_detach    = new Checkbox( "Detach", method, true );
    method_bye       = new Checkbox( "Bye", method, false );
    method_terminate = new Checkbox( "Terminate", method, false );

    terminate_all    = new Checkbox( "Close all connections" );
    terminate_all.setState( true );
    terminate_all.disable();

    blurb = new TextField( 40 );

    ok     = new CalButton( "Ok" );
    cancel = new CalButton( "Cancel" );
    help   = new CalButton( "Help" );
    help.disable();

    layout = new GridBagLayout();
    setLayout( layout );
    gbc = new GridBagConstraints();
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    gbc.ipady = 4;

    addObject( new Label( "" ) );
    addObject( text );

    gbc.anchor = GridBagConstraints.WEST;
    addObject( method_detach );
    addObject( method_bye );
    addObject( method_terminate );

    gbc.anchor = GridBagConstraints.CENTER;
    addObject( terminate_all );

    gbc.gridwidth = 1;
    addObject( new Label( "Blurb: " ) );
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    addObject( blurb );

    gbc.gridwidth = 1;
    gbc.weightx = 1.0;
    gbc.weighty = 1.0;
    addObject( ok );
    addObject( cancel );
    gbc.gridwidth = GridBagConstraints.REMAINDER;
    addObject( help );

    addObject( new Label( "" ) );
    
    pack();
    show();
  }

//---------------------------------------------------------------------------

  void addObject( Component o ){
    layout.setConstraints( o, gbc );
    add( o );
  }

//---------------------------------------------------------------------------

  public boolean handleEvent( Event e ){
    boolean do_terminate = method_terminate.getState();

    // @@@ This isn't working...
    if( do_terminate ){
      blurb.disable();
    } else {
      blurb.enable();
    }

    if( (e.target == ok) && (CalButton.buttonHit( e )) ){
      do_quit();      
      dispose();
      return true;
    } else if( (e.target == cancel) && (CalButton.buttonHit( e )) ){
      dispose();
      return true;
    } else if( (e.target == help) && (CalButton.buttonHit( e )) ){
      // @@@
      return false;
    } else if( e.id == Event.KEY_PRESS ){
      switch( e.key ){
        case '\n':
          do_quit();
          dispose();
          return true;
        case '\027':    // ESC
          dispose();
          return true;
      }
    }

    return false;
  }

//---------------------------------------------------------------------------

  void do_quit(){
    boolean do_detach    = method_detach.getState();
    boolean do_bye       = method_bye.getState();
    boolean do_terminate = method_terminate.getState();

    boolean do_terminate_all = terminate_all.getState();

    String blurbtext = blurb.getText();

    String send;


    if( do_detach ){
      send = "/DETACH";
      if( blurbtext.length() != 0 ){
        send = send + " " + blurbtext;
      }
      tonet.put( send + '\n' );
      CalValue.put( "SYSTEM", "status", "standby" );
    } else if( do_bye ){
      send = "/BYE";
      if( blurbtext.length() != 0 ){
        send = send + " " + blurbtext;
      }
      tonet.put( send + '\n' );
      CalValue.put( "SYSTEM", "status", "standby" );
    } else if( do_terminate ){
      CalValue.put( "SYSTEM", "status", "shutdown" );
    } else {
      // HUH?
    }
  }

//---------------------------------------------------------------------------

}

//***************************************************************************

