// $Id: Window.java,v 1.2 1996/11/25 04:19:42 asf Exp $

//    This file is part of Cafe au Lys
//    Copyright (C) 1996  Allen S. Firstenberg
// 
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
// 
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
// 
//    You should have received a copy of the GNU General Public License
//    along with this program; if not, write to the Free Software
//    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

import java.awt.*;
import java.net.*;
import java.util.*;

import Buffer;

//***************************************************************************

abstract class CalWindow extends CalFrame implements Runnable{

  String name;
  CalStatus status;
  Buffer parser;
  Buffer network;
  Buffer input;

  Thread thread;
  boolean running;

//---------------------------------------------------------------------------

  CalWindow( String n, CalStatus stat, 
             Buffer fromnet, Buffer tonet, Buffer toparser ){
    super( "CaL: " + n );

    name = n;
    input = fromnet;
    parser = toparser;
    network = tonet;
    status = stat;

    System.out.println( toString() );
    System.out.println( super.toString() );
  }

//---------------------------------------------------------------------------

  public boolean handleEvent( Event evt ){
  // @@@ was action

    if( evt.id == Event.WINDOW_DESTROY ){
      return true;
//    } else if( evt.target instanceof MenuItemAction ){
//      return ((MenuItemAction)evt.target).action( evt, new Object() );
    } else if( evt.id == Event.GOT_FOCUS ){
      System.out.println( "CalWindow got focus" );
      return super.handleEvent( evt );
    }

    return super.handleEvent( evt );
  }

//---------------------------------------------------------------------------

  public void start(){
    if( thread == null ){
      thread = new Thread( this, name );
      thread.start();
    }
  }

//---------------------------------------------------------------------------

  abstract public void run();
  // This needs to be a loop, generally centering around a 
  //   while( running ){}
  // block with a
  //   dispose()
  // at the end
  // @@@ Should the dispose be in the stop method?

//---------------------------------------------------------------------------

  public void stop(){
    System.out.println( "Stopping " + thread.getName() );
    if( thread != null ){
      thread.stop();
      thread = null;
    }
    System.out.println( "stopped" );
  }

//---------------------------------------------------------------------------

  public String getName(){
    return name;
  }

//---------------------------------------------------------------------------

  public Buffer getParseBuffer(){
    return parser;
  }

//---------------------------------------------------------------------------

  public Buffer getNetworkBuffer(){
    return network;
  }

//---------------------------------------------------------------------------

  public Buffer getInputBuffer(){
    return input;
  }

//---------------------------------------------------------------------------

  public void dispose(){
    // Some systems (Netscape) dispose of things incorrectly, so we
    // just hide the window in these cases.

    try{
      if( CalValue.get("SYSTEM", "os").equalsIgnoreCase("UNIX") ){
        System.out.println( "UNIX" );
        hide();
      } else {
        System.out.println( "not UNIX" );
        super.dispose();
      }
    } catch( CalUnknownValueException cuve ){
      System.out.println( "Couldn't determine OS" );
      hide();
    }

    

  }

//---------------------------------------------------------------------------

}

//***************************************************************************

